//
//  PlaylistViewController+Ext.swift
//  TSLiveWallpaper
//
//  Created by nkl on 2024/12/26.
//

import Foundation
import TSVideoKit
//import ADManager

extension PlaylistViewController {
    func addTargets() {
        searchBar.addTarget(self, action: #selector(showSearchViewController), for: .touchUpInside)
        importButton.addTarget(self, action: #selector(showImportMenuView), for: .touchUpInside)
    }

    @objc func showSearchViewController() {
        let vc = LocalSearchViewController()
        vc.hidesBottomBarWhenPushed = true
        self.navigationController?.pushViewController(vc, animated: true)
        
//        if PurchaseManager.default.isVip {
//            if TSConfiguration.isYs {
//                let vc = SearchOnlineViewController()
//                vc.hidesBottomBarWhenPushed = true
//                navigationController?.pushViewController(vc, animated: true)
//            } else {
//                let vc = LocalSearchViewController()
//                vc.hidesBottomBarWhenPushed = true
//                navigationController?.pushViewController(vc, animated: true)
//            }
//        } else {
//            ADManager.shared.showAd(scene: ADScene.searchInsert, from: self) { state in
//                if state == .finished || state == .fail {
//                    if TSConfiguration.isYs {
//                        ADManager.shared.prepareAd(scenes: [ADScene.downloadInsert])
//                        let vc = SearchOnlineViewController()
//                        vc.hidesBottomBarWhenPushed = true
//                        self.navigationController?.pushViewController(vc, animated: true)
//                    } else {
//                        let vc = LocalSearchViewController()
//                        vc.hidesBottomBarWhenPushed = true
//                        self.navigationController?.pushViewController(vc, animated: true)
//                    }
//                }
//            }
//        }
    }

    @objc func showRecentlyList() {
        let vModel: PlayListDetaiViewModel = .init()
        vModel.listType = .recently
        let vc = PlaylistDetailViewController(viewModel: vModel)
        vc.hidesBottomBarWhenPushed = true
        navigationController?.pushViewController(vc, animated: true)
    }

    @objc func showLikeViewController() {
        //        ADManager.shared.showAd(scene: ADScene.playlist, from: self) { state in
        //            if state == .finished || state == .fail {
        let vModel: PlayListDetaiViewModel = .init()
        vModel.listType = .favourite
        let vc = PlaylistDetailViewController(viewModel: vModel)
        vc.hidesBottomBarWhenPushed = true
        navigationController?.pushViewController(vc, animated: true)
        //            }
        //        }
    }

    @objc func showImportMenuView() {
        let menuView = BubbleMenuView()
        menuView.position = FitManager.isAr ? .topLeft : .topRight
        menuView.actionHanlder = { type in
            self.menuClick(type: type)
        }
        view.addSubview(menuView)
        menuView.snp.makeConstraints { make in
            make.trailing.equalTo(self.importButton)
            make.width.equalTo(150)
            make.top.equalTo(self.importButton.snp.bottom).offset(0)
        }
        importMenuView = menuView
    }

    func menuClick(type: ImportSource) {
        importMenuView?.removeFromSuperview()
        if type == .library {
            ImportFilesManager.shared.openPhotoLibrary(parent: self)
        } else if type == .file {
            ImportFilesManager.shared.openFileDocument(parent: self, completion: nil)
        }
    }
}
